diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/test/test-uniform-planar-array.cc ns-3.42/src/antenna/test/test-uniform-planar-array.cc
--- ns-3.41/src/antenna/test/test-uniform-planar-array.cc	2024-02-09 14:44:07.849789600 -0800
+++ ns-3.42/src/antenna/test/test-uniform-planar-array.cc	2024-05-29 15:29:46.916073000 -0700
@@ -215,7 +215,7 @@
 };
 
 UniformPlanarArrayTestSuite::UniformPlanarArrayTestSuite()
-    : TestSuite("uniform-planar-array-test", UNIT)
+    : TestSuite("uniform-planar-array-test", Type::UNIT)
 {
     Ptr<AntennaModel> isotropic = CreateObject<IsotropicAntennaModel>();
     Ptr<AntennaModel> tgpp = CreateObject<ThreeGppAntennaModel>();
@@ -233,7 +233,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(0), DegreesToRadians(90)),
                                                0.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -243,7 +243,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(0), DegreesToRadians(90)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -253,7 +253,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(90), DegreesToRadians(90)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -263,7 +263,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(-90), DegreesToRadians(90)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -273,7 +273,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(180), DegreesToRadians(90)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -283,7 +283,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(-180), DegreesToRadians(90)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -293,7 +293,7 @@
                                                DegreesToRadians(45),
                                                Angles(DegreesToRadians(0), DegreesToRadians(135)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -303,7 +303,7 @@
                                                DegreesToRadians(-45),
                                                Angles(DegreesToRadians(0), DegreesToRadians(45)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -313,7 +313,7 @@
                                                DegreesToRadians(90),
                                                Angles(DegreesToRadians(0), DegreesToRadians(180)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                1,
                                                1,
@@ -323,7 +323,7 @@
                                                DegreesToRadians(-90),
                                                Angles(DegreesToRadians(0), DegreesToRadians(0)),
                                                8.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // linear array
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
@@ -335,7 +335,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(0), DegreesToRadians(90)),
                                                18.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                10,
                                                1,
@@ -345,7 +345,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(90), DegreesToRadians(90)),
                                                18.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                10,
                                                1,
@@ -355,7 +355,7 @@
                                                DegreesToRadians(45),
                                                Angles(DegreesToRadians(0), DegreesToRadians(135)),
                                                18.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // planar array
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
@@ -367,7 +367,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(0), DegreesToRadians(90)),
                                                28.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                10,
                                                10,
@@ -377,7 +377,7 @@
                                                DegreesToRadians(0),
                                                Angles(DegreesToRadians(90), DegreesToRadians(90)),
                                                28.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new UniformPlanarArrayTestCase(tgpp,
                                                10,
                                                10,
@@ -387,7 +387,7 @@
                                                DegreesToRadians(45),
                                                Angles(DegreesToRadians(0), DegreesToRadians(135)),
                                                28.0),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 static UniformPlanarArrayTestSuite staticUniformPlanarArrayTestSuiteInstance;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/aodv/examples/aodv.cc ns-3.42/src/aodv/examples/aodv.cc
--- ns-3.41/src/aodv/examples/aodv.cc	2024-02-09 14:44:07.849789600 -0800
+++ ns-3.42/src/aodv/examples/aodv.cc	2024-05-29 15:29:46.916073000 -0700
@@ -34,6 +34,12 @@
 using namespace ns3;
 
 /**
+ * \defgroup aodv-examples AODV Examples
+ * \ingroup aodv
+ * \ingroup examples
+ */
+
+/**
  * \ingroup aodv-examples
  * \ingroup examples
  * \brief Test script.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/aodv/model/aodv-routing-protocol.cc ns-3.42/src/aodv/model/aodv-routing-protocol.cc
--- ns-3.41/src/aodv/model/aodv-routing-protocol.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/aodv/model/aodv-routing-protocol.cc	2024-05-29 15:29:46.916073000 -0700
@@ -1685,33 +1685,24 @@
     RoutingTableEntry toDst;
     if (m_routingTable.LookupRoute(dst, toDst))
     {
-        /*
-         * The existing entry is updated only in the following circumstances:
-         * (i) the sequence number in the routing table is marked as invalid in route table entry.
-         */
-        if (!toDst.GetValidSeqNo())
-        {
-            m_routingTable.Update(newEntry);
-        }
-        // (ii)the Destination Sequence Number in the RREP is greater than the node's copy of the
-        // destination sequence number and the known value is valid,
-        else if ((int32_t(rrepHeader.GetDstSeqno()) - int32_t(toDst.GetSeqNo())) > 0)
-        {
-            m_routingTable.Update(newEntry);
-        }
-        else
-        {
+        // The existing entry is updated only in the following circumstances:
+        if (
+            // (i) the sequence number in the routing table is marked as invalid in route table
+            // entry.
+            (!toDst.GetValidSeqNo()) ||
+
+            // (ii) the Destination Sequence Number in the RREP is greater than the node's copy of
+            // the destination sequence number and the known value is valid,
+            ((int32_t(rrepHeader.GetDstSeqno()) - int32_t(toDst.GetSeqNo())) > 0) ||
+
             // (iii) the sequence numbers are the same, but the route is marked as inactive.
-            if ((rrepHeader.GetDstSeqno() == toDst.GetSeqNo()) && (toDst.GetFlag() != VALID))
-            {
-                m_routingTable.Update(newEntry);
-            }
-            // (iv)  the sequence numbers are the same, and the New Hop Count is smaller than the
+            (rrepHeader.GetDstSeqno() == toDst.GetSeqNo() && toDst.GetFlag() != VALID) ||
+
+            // (iv) the sequence numbers are the same, and the New Hop Count is smaller than the
             // hop count in route table entry.
-            else if ((rrepHeader.GetDstSeqno() == toDst.GetSeqNo()) && (hop < toDst.GetHop()))
-            {
-                m_routingTable.Update(newEntry);
-            }
+            (rrepHeader.GetDstSeqno() == toDst.GetSeqNo() && hop < toDst.GetHop()))
+        {
+            m_routingTable.Update(newEntry);
         }
     }
     else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/aodv/test/aodv-id-cache-test-suite.cc ns-3.42/src/aodv/test/aodv-id-cache-test-suite.cc
--- ns-3.41/src/aodv/test/aodv-id-cache-test-suite.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/aodv/test/aodv-id-cache-test-suite.cc	2024-05-29 15:29:46.920073000 -0700
@@ -118,9 +118,9 @@
 {
   public:
     IdCacheTestSuite()
-        : TestSuite("aodv-routing-id-cache", UNIT)
+        : TestSuite("aodv-routing-id-cache", Type::UNIT)
     {
-        AddTestCase(new IdCacheTest, TestCase::QUICK);
+        AddTestCase(new IdCacheTest, TestCase::Duration::QUICK);
     }
 } g_idCacheTestSuite; ///< the test suite
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/aodv/test/aodv-regression.cc ns-3.42/src/aodv/test/aodv-regression.cc
--- ns-3.41/src/aodv/test/aodv-regression.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/aodv/test/aodv-regression.cc	2024-05-29 15:29:46.920073000 -0700
@@ -52,17 +52,18 @@
 {
   public:
     AodvRegressionTestSuite()
-        : TestSuite("routing-aodv-regression", SYSTEM)
+        : TestSuite("routing-aodv-regression", Type::SYSTEM)
     {
         SetDataDir(NS_TEST_SOURCEDIR);
         // General RREQ-RREP-RRER test case
-        AddTestCase(new ChainRegressionTest("aodv-chain-regression-test"), TestCase::QUICK);
+        AddTestCase(new ChainRegressionTest("aodv-chain-regression-test"),
+                    TestCase::Duration::QUICK);
         // \bugid{606} test case, should crash if bug is not fixed
         AddTestCase(new ChainRegressionTest("bug-606-test", Seconds(10), 3, Seconds(1)),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         // \bugid{772} UDP test case
         AddTestCase(new Bug772ChainTest("udp-chain-test", "ns3::UdpSocketFactory", Seconds(3), 10),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
     }
 } g_aodvRegressionTestSuite; ///< the test suite
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/aodv/test/aodv-test-suite.cc ns-3.42/src/aodv/test/aodv-test-suite.cc
--- ns-3.41/src/aodv/test/aodv-test-suite.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/aodv/test/aodv-test-suite.cc	2024-05-29 15:29:46.920073000 -0700
@@ -739,18 +739,18 @@
 {
   public:
     AodvTestSuite()
-        : TestSuite("routing-aodv", UNIT)
+        : TestSuite("routing-aodv", Type::UNIT)
     {
-        AddTestCase(new NeighborTest, TestCase::QUICK);
-        AddTestCase(new TypeHeaderTest, TestCase::QUICK);
-        AddTestCase(new RreqHeaderTest, TestCase::QUICK);
-        AddTestCase(new RrepHeaderTest, TestCase::QUICK);
-        AddTestCase(new RrepAckHeaderTest, TestCase::QUICK);
-        AddTestCase(new RerrHeaderTest, TestCase::QUICK);
-        AddTestCase(new QueueEntryTest, TestCase::QUICK);
-        AddTestCase(new AodvRqueueTest, TestCase::QUICK);
-        AddTestCase(new AodvRtableEntryTest, TestCase::QUICK);
-        AddTestCase(new AodvRtableTest, TestCase::QUICK);
+        AddTestCase(new NeighborTest, TestCase::Duration::QUICK);
+        AddTestCase(new TypeHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new RreqHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new RrepHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new RrepAckHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new RerrHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new QueueEntryTest, TestCase::Duration::QUICK);
+        AddTestCase(new AodvRqueueTest, TestCase::Duration::QUICK);
+        AddTestCase(new AodvRtableEntryTest, TestCase::Duration::QUICK);
+        AddTestCase(new AodvRtableTest, TestCase::Duration::QUICK);
     }
 } g_aodvTestSuite; ///< the test suite
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/aodv/test/loopback.cc ns-3.42/src/aodv/test/loopback.cc
--- ns-3.41/src/aodv/test/loopback.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/aodv/test/loopback.cc	2024-05-29 15:29:46.920073000 -0700
@@ -197,11 +197,11 @@
 {
   public:
     AodvLoopbackTestSuite()
-        : TestSuite("routing-aodv-loopback", SYSTEM)
+        : TestSuite("routing-aodv-loopback", Type::SYSTEM)
     {
         SetDataDir(NS_TEST_SOURCEDIR);
         // UDP Echo loopback test case
-        AddTestCase(new LoopbackTestCase(), TestCase::QUICK);
+        AddTestCase(new LoopbackTestCase(), TestCase::Duration::QUICK);
     }
 } g_aodvLoopbackTestSuite; ///< the test suite
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/bulk-send-helper.cc ns-3.42/src/applications/helper/bulk-send-helper.cc
--- ns-3.41/src/applications/helper/bulk-send-helper.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/bulk-send-helper.cc	2024-05-29 15:29:46.920073000 -0700
@@ -21,59 +21,16 @@
 
 #include "bulk-send-helper.h"
 
-#include "ns3/inet-socket-address.h"
-#include "ns3/names.h"
-#include "ns3/packet-socket-address.h"
-#include "ns3/string.h"
+#include <ns3/string.h>
 
 namespace ns3
 {
 
-BulkSendHelper::BulkSendHelper(std::string protocol, Address address)
+BulkSendHelper::BulkSendHelper(const std::string& protocol, const Address& address)
+    : ApplicationHelper("ns3::BulkSendApplication")
 {
-    m_factory.SetTypeId("ns3::BulkSendApplication");
     m_factory.Set("Protocol", StringValue(protocol));
     m_factory.Set("Remote", AddressValue(address));
 }
 
-void
-BulkSendHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-BulkSendHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-BulkSendHelper::Install(std::string nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-BulkSendHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-BulkSendHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Application> app = m_factory.Create<Application>();
-    node->AddApplication(app);
-
-    return app;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/bulk-send-helper.h ns-3.42/src/applications/helper/bulk-send-helper.h
--- ns-3.41/src/applications/helper/bulk-send-helper.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/bulk-send-helper.h	2024-05-29 15:29:46.920073000 -0700
@@ -22,15 +22,7 @@
 #ifndef BULK_SEND_HELPER_H
 #define BULK_SEND_HELPER_H
 
-#include "ns3/address.h"
-#include "ns3/application-container.h"
-#include "ns3/attribute.h"
-#include "ns3/net-device.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
-
-#include <stdint.h>
-#include <string>
+#include <ns3/application-helper.h>
 
 namespace ns3
 {
@@ -40,7 +32,7 @@
  * \brief A helper to make it easier to instantiate an ns3::BulkSendApplication
  * on a set of nodes.
  */
-class BulkSendHelper
+class BulkSendHelper : public ApplicationHelper
 {
   public:
     /**
@@ -53,58 +45,9 @@
      * \param address the address of the remote node to send traffic
      *        to.
      */
-    BulkSendHelper(std::string protocol, Address address);
-
-    /**
-     * Helper function used to set the underlying application attributes,
-     * _not_ the socket attributes.
-     *
-     * \param name the name of the application attribute to set
-     * \param value the value of the application attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-    /**
-     * Install an ns3::BulkSendApplication on each node of the input container
-     * configured with all the attributes set with SetAttribute.
-     *
-     * \param c NodeContainer of the set of nodes on which an BulkSendApplication
-     * will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(NodeContainer c) const;
-
-    /**
-     * Install an ns3::BulkSendApplication on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param node The node on which an BulkSendApplication will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Install an ns3::BulkSendApplication on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param nodeName The node on which an BulkSendApplication will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(std::string nodeName) const;
-
-  private:
-    /**
-     * Install an ns3::BulkSendApplication on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param node The node on which an BulkSendApplication will be installed.
-     * \returns Ptr to the application installed.
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-
-    ObjectFactory m_factory; //!< Object factory.
+    BulkSendHelper(const std::string& protocol, const Address& address);
 };
 
 } // namespace ns3
 
-#endif /* ON_OFF_HELPER_H */
+#endif /* BULK_SEND_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/on-off-helper.cc ns-3.42/src/applications/helper/on-off-helper.cc
--- ns-3.41/src/applications/helper/on-off-helper.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/on-off-helper.cc	2024-05-29 15:29:46.920073000 -0700
@@ -16,88 +16,24 @@
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
+
 #include "on-off-helper.h"
 
-#include "ns3/data-rate.h"
-#include "ns3/inet-socket-address.h"
-#include "ns3/names.h"
-#include "ns3/onoff-application.h"
-#include "ns3/packet-socket-address.h"
-#include "ns3/random-variable-stream.h"
-#include "ns3/string.h"
-#include "ns3/uinteger.h"
+#include <ns3/onoff-application.h>
+#include <ns3/string.h>
+#include <ns3/uinteger.h>
 
 namespace ns3
 {
 
-OnOffHelper::OnOffHelper(std::string protocol, Address address)
+OnOffHelper::OnOffHelper(const std::string& protocol, const Address& address)
+    : ApplicationHelper("ns3::OnOffApplication")
 {
-    m_factory.SetTypeId("ns3::OnOffApplication");
     m_factory.Set("Protocol", StringValue(protocol));
     m_factory.Set("Remote", AddressValue(address));
 }
 
 void
-OnOffHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-OnOffHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-OnOffHelper::Install(std::string nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-OnOffHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-OnOffHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Application> app = m_factory.Create<Application>();
-    node->AddApplication(app);
-
-    return app;
-}
-
-int64_t
-OnOffHelper::AssignStreams(NodeContainer c, int64_t stream)
-{
-    int64_t currentStream = stream;
-    Ptr<Node> node;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        node = (*i);
-        for (uint32_t j = 0; j < node->GetNApplications(); j++)
-        {
-            Ptr<OnOffApplication> onoff = DynamicCast<OnOffApplication>(node->GetApplication(j));
-            if (onoff)
-            {
-                currentStream += onoff->AssignStreams(currentStream);
-            }
-        }
-    }
-    return (currentStream - stream);
-}
-
-void
 OnOffHelper::SetConstantRate(DataRate dataRate, uint32_t packetSize)
 {
     m_factory.Set("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1000]"));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/on-off-helper.h ns-3.42/src/applications/helper/on-off-helper.h
--- ns-3.41/src/applications/helper/on-off-helper.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/on-off-helper.h	2024-05-29 15:29:46.920073000 -0700
@@ -16,31 +16,24 @@
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
+
 #ifndef ON_OFF_HELPER_H
 #define ON_OFF_HELPER_H
 
-#include "ns3/address.h"
-#include "ns3/application-container.h"
-#include "ns3/attribute.h"
-#include "ns3/net-device.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
-#include "ns3/onoff-application.h"
+#include <ns3/application-helper.h>
+#include <ns3/data-rate.h>
 
 #include <stdint.h>
-#include <string>
 
 namespace ns3
 {
 
-class DataRate;
-
 /**
  * \ingroup onoff
  * \brief A helper to make it easier to instantiate an ns3::OnOffApplication
  * on a set of nodes.
  */
-class OnOffHelper
+class OnOffHelper : public ApplicationHelper
 {
   public:
     /**
@@ -53,15 +46,7 @@
      * \param address the address of the remote node to send traffic
      *        to.
      */
-    OnOffHelper(std::string protocol, Address address);
-
-    /**
-     * Helper function used to set the underlying application attributes.
-     *
-     * \param name the name of the application attribute to set
-     * \param value the value of the application attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
+    OnOffHelper(const std::string& protocol, const Address& address);
 
     /**
      * Helper function to set a constant rate source.  Equivalent to
@@ -72,59 +57,6 @@
      * \param packetSize size in bytes of the packet payloads generated
      */
     void SetConstantRate(DataRate dataRate, uint32_t packetSize = 512);
-
-    /**
-     * Install an ns3::OnOffApplication on each node of the input container
-     * configured with all the attributes set with SetAttribute.
-     *
-     * \param c NodeContainer of the set of nodes on which an OnOffApplication
-     * will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(NodeContainer c) const;
-
-    /**
-     * Install an ns3::OnOffApplication on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param node The node on which an OnOffApplication will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Install an ns3::OnOffApplication on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param nodeName The node on which an OnOffApplication will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(std::string nodeName) const;
-
-    /**
-     * Assign a fixed random variable stream number to the random variables
-     * used by this model.  Return the number of streams (possibly zero) that
-     * have been assigned.  The Install() method should have previously been
-     * called by the user.
-     *
-     * \param stream first stream index to use
-     * \param c NodeContainer of the set of nodes for which the OnOffApplication
-     *          should be modified to use a fixed stream
-     * \return the number of stream indices assigned by this helper
-     */
-    int64_t AssignStreams(NodeContainer c, int64_t stream);
-
-  private:
-    /**
-     * Install an ns3::OnOffApplication on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param node The node on which an OnOffApplication will be installed.
-     * \returns Ptr to the application installed.
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-
-    ObjectFactory m_factory; //!< Object factory.
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/packet-sink-helper.cc ns-3.42/src/applications/helper/packet-sink-helper.cc
--- ns-3.41/src/applications/helper/packet-sink-helper.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/packet-sink-helper.cc	2024-05-29 15:29:46.920073000 -0700
@@ -19,58 +19,16 @@
 
 #include "packet-sink-helper.h"
 
-#include "ns3/inet-socket-address.h"
-#include "ns3/names.h"
-#include "ns3/string.h"
+#include <ns3/string.h>
 
 namespace ns3
 {
 
-PacketSinkHelper::PacketSinkHelper(std::string protocol, Address address)
+PacketSinkHelper::PacketSinkHelper(const std::string& protocol, const Address& address)
+    : ApplicationHelper("ns3::PacketSink")
 {
-    m_factory.SetTypeId("ns3::PacketSink");
     m_factory.Set("Protocol", StringValue(protocol));
     m_factory.Set("Local", AddressValue(address));
 }
 
-void
-PacketSinkHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-PacketSinkHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-PacketSinkHelper::Install(std::string nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-PacketSinkHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-PacketSinkHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Application> app = m_factory.Create<Application>();
-    node->AddApplication(app);
-
-    return app;
-}
-
 } // namespace ns3
